<template>
  <div class="cp-fight">
    <div class="health">
      <!-- Batman -->
      <div class="caracter caracter__hero01">
        <div class="name name__hero01">{{hero01.name}}</div>
        <div class="health__hero01">
          <div class="health__bar">
            <div class="health__bar-value" :style="{width: hero01.percentHealth + '%' }"></div>
          </div>
          {{hero01.health}}
        </div>
      </div>
      <!-- Aquaman -->
      <div class="caracter caracter__hero02">
        <div class="name name__hero02">{{hero02.name}}</div>
        <div class="health__hero02">
          <div class="health__bar">
            <div class="health__bar-value" :style="{width: hero02.percentHealth + '%' }"></div>
          </div>
          {{hero02.health}}
        </div>
      </div>
    </div>

    <div class="stage">
      <CpHero class="cp-hero" :hero="hero01"/>
      <CpHero class="cp-hero2" :hero="hero02"/>
    </div>
  </div>
</template>
<script>
import Hero from "@/classes/Hero.js";
import CpHero from "@/components/Hero";
import DataHeroes from "@/assets/data/hero.json";

export default {
  name: "Fight",
  components: {
    CpHero
  },
  props: {
    msg: { type: String, default: "Joao est beau" }
  },
  data() {
    // Instancier les heros
    let hero01data = DataHeroes["batman"];
    let hero01 = new Hero("batman", hero01data.health);
    hero01.soundPunch = hero01data.soundPunch;
    hero01.sprite = hero01data.sprite;

    let hero02data = DataHeroes["aquaman"];
    let hero02 = new Hero("aquaman", hero02data.health);
    hero02.soundPunch = hero02data.soundPunch;
    hero02.sprite = hero02data.sprite;

    return {
      hero01: hero01,
      hero02: hero02
    };
  },
  mounted() {
    window.addEventListener("keypress", e => {
      if (e.key == "a") {
        console.log("Aquaman attack");
        this.hero01.punch(this.hero02);
      }
      if (e.key == "l") {
        console.log("batman attack");
        this.hero02.punch(this.hero01);
      }
    });
  }
};
</script>


<style lang="scss" scoped>
.caracter {
  width: 48%;
}
.name {
  font-size: 2vw;
  text-transform: uppercase;
}

.health {
  display: flex;
  justify-content: space-between;
  &__bar {
    width: 100%;
    height: 20px;
    background: lightgray;
    display: flex;

    &-value {
      width: 100%;
      background: green;
    }
  }
}
 .stage{
    display: flex;
    justify-content: center;
  }
</style>